#include <iostream>

class A {
public:
	void f() { std::cout << "Af "; }
	virtual void g() { std::cout << "Ag\n"; }
};

class B : public A {
public:
	void f() { std::cout << "Bf "; }
	void g() override { std::cout << "Bg\n"; }
};

int main() {
	A a;
	a.f();
	a.g();

	B b;
	b.f();
	b.g();

	A& refa = a;
	refa.f();
	refa.g();

	A& refb = b;
	refb.f();
	refb.g();
}
